Package weka.filters.unsupervised.attribute

# Class Center

java.lang.Object
weka.filters.Filter
weka.filters.unsupervised.attribute.PotentialClassIgnorer
weka.filters.unsupervised.attribute.Center

All Implemented Interfaces:
  `Serializable`, `CapabilitiesHandler`, `OptionHandler`, `RevisionHandler`, `Sourcable`, `UnsupervisedFilter`

public class Center extends PotentialClassIgnorer implements UnsupervisedFilter, Sourcable
Centers all numeric attributes in the given dataset to have zero mean (apart from the class attribute, if set).

Valid options are:

     -unset-class-temporarily
      Unsets the class index temporarily before the filter is
      applied to the data.
      (default: no)

Version:
  $Revision: 5543 $
Author:
  Eibe Frank (eibe@cs.waikato.ac.nz), FracPete (fracpete at waikato dot ac dot nz)
See Also:
  - Serialized Form

## Constructor Summary

Constructors
Constructor
Description
`Center()`

## Method Summary

Modifier and Type
Method
Description
`boolean`
`batchFinished()`
Signify that this batch of input to the filter is finished.
`Capabilities`
`getCapabilities()`
Returns the Capabilities of this filter.
`String`
`getRevision()`
Returns the revision string.
`String`
`globalInfo()`
Returns a string describing this filter
`boolean`
`input(Instance instance)`
Input an instance for filtering.
`static void`
`main(String[] args)`
Main method for running this filter.
`boolean`
`setInputFormat(Instances instanceInfo)`
Sets the format of the input instances.
`String`
`toSource(String className, Instances data)`
Returns a string that describes the filter as source.

### Methods inherited from class weka.filters.unsupervised.attribute.PotentialClassIgnorer

`getIgnoreClass, getOptions, getOutputFormat, ignoreClassTipText, listOptions, setIgnoreClass, setOptions`

### Methods inherited from class weka.filters.Filter

`batchFilterFile, filterFile, getCapabilities, isFirstBatchDone, isNewBatch, isOutputFormatDefined, makeCopies, makeCopy, numPendingOutput, output, outputPeek, toString, useFilter, wekaStaticWrapper`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### Center

public Center()

## Method Details

### globalInfo

public String globalInfo()
Returns a string describing this filter

Returns:
  a description of the filter suitable for displaying in the explorer/experimenter gui

### getCapabilities

public Capabilities getCapabilities()
Returns the Capabilities of this filter.

Specified by:
  `getCapabilities` in interface `CapabilitiesHandler`
Overrides:
  `getCapabilities` in class `Filter`
Returns:
  the capabilities of this object
See Also:
  - `Capabilities`

### setInputFormat

public boolean setInputFormat(Instances instanceInfo) throws Exception
Sets the format of the input instances.

Overrides:
  `setInputFormat` in class `PotentialClassIgnorer`
Parameters:
  `instanceInfo` - an Instances object containing the input instance structure (any instances contained in the object are ignored - only the structure is required).
Returns:
  true if the outputFormat may be collected immediately
Throws:
  `Exception` - if the input format can't be set successfully

### input

public boolean input(Instance instance)
Input an instance for filtering. Filter requires all training instances be read before producing output.

Overrides:
  `input` in class `Filter`
Parameters:
  `instance` - the input instance
Returns:
  true if the filtered instance may now be collected with output().
Throws:
  `IllegalStateException` - if no input format has been set.

### batchFinished

public boolean batchFinished()
Signify that this batch of input to the filter is finished. If the filter requires all instances prior to filtering, output() may now be called to retrieve the filtered instances.

Overrides:
  `batchFinished` in class `Filter`
Returns:
  true if there are instances pending output
Throws:
  `IllegalStateException` - if no input structure has been defined

### toSource

public String toSource(String className, Instances data) throws Exception
Returns a string that describes the filter as source. The filter will be contained in a class with the given name (there may be auxiliary classes), and will contain two methods with these signatures:

     // converts one row
     public static Object[] filter(Object[] i);
     // converts a full dataset (first dimension is row index)
     public static Object[][] filter(Object[][] i);

where the array `i` contains elements that are either Double, String, with missing values represented as null. The generated code is public domain and comes with no warranty.

Specified by:
  `toSource` in interface `Sourcable`
Parameters:
  `className` - the name that should be given to the source class.
  `data` - the dataset used for initializing the filter
Returns:
  the object source described by a string
Throws:
  `Exception` - if the source can't be computed

### getRevision

public String getRevision()
Returns the revision string.

Specified by:
  `getRevision` in interface `RevisionHandler`
Overrides:
  `getRevision` in class `Filter`
Returns:
  the revision

### main

public static void main(String[] args)
Main method for running this filter.

Parameters:
  `args` - should contain arguments to the filter: use -h for help